import { continuedIndent, indentNodeProp, foldNodeProp, LRLanguage, } from "@codemirror/language";
import { parser } from "lezer-tasl";
import { styleNodeProp } from "./style.js";
export const syntax = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Product: continuedIndent({ except: /^\s*\}/ }),
                Coproduct: continuedIndent({ except: /^\s*\]/ }),
            }),
            foldNodeProp.add({
                Product(subtree) {
                    return { from: subtree.from + 1, to: subtree.to - 1 };
                },
                Coproduct(subtree) {
                    return { from: subtree.from + 1, to: subtree.to - 1 };
                },
            }),
            styleNodeProp,
        ],
    }),
    languageData: {
        closeBrackets: { brackets: ["[", "{"] },
        indentOnInput: /^\s*[\}\]]$/,
        commentTokens: { line: "#" },
    },
});
